//+---------------------------------------------------------------------+
//| PathFunctions.h:     DLL.       |
//|        .       |
//| Copyright  2010,   (Zhunko)                              |
//| e-mail: vadim@zhunko.ru                     29.05.2011 - 27.02.2014 |
//+---------------------------------------------------------------------+
#ifndef EXPFUNC
 #define EXPFUNC(type)   __declspec(dllexport) type __stdcall
#endif
//
//          .
//
// 1.1.    .   ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathCheckA(LPCSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 1.2.    .   ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathCheckW(LPCWSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 1.3.    .   ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathCheck  PathCheckW
#else
 #define PathCheck  PathCheckA
#endif
//==============================================================================================================================================================================================================================================================
// 2.1.       (  ).    ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathClearContentsA(LPCSTR szPath); //           .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.2.       (  ).    ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathClearContentsW(LPCWSTR szPath); //           .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 2.3.       (  ).    ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathClearContents  PathClearContentsW
#else
 #define PathClearContents  PathClearContentsA
#endif
//==============================================================================================================================================================================================================================================================
// 3.1.         .    ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathClearFromFilesA(LPCSTR szPath); //           .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.2.         .    ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathClearFromFilesW(LPCWSTR szPath); //           .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 3.3.         .    ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathClearFromFiles  PathClearFromFilesW
#else
 #define PathClearFromFiles  PathClearFromFilesA
#endif
//==============================================================================================================================================================================================================================================================
// 4.1.    ,    .   ,    .     .   ,   TRUE,  - FALSE.
//         ANSI-.
EXPFUNC(BOOL) PathCopyA(LPCSTR szExistingPath, //     .
                        LPCSTR szNewPath);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.2.    ,    .   ,    .     .   ,   TRUE,  - FALSE.
//         UNICODE-.
EXPFUNC(BOOL) PathCopyW(LPCWSTR szExistingPath, //     .
                        LPCWSTR szNewPath);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 4.3.    ,    .   ,    .     .   ,   TRUE,  - FALSE.
//            .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathCopy  PathCopyW
#else
 #define PathCopy  PathCopyA
#endif
//==============================================================================================================================================================================================================================================================
// 5.1.   .      ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathCreateA(LPCSTR szPath); //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.2.   .      ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathCreateW(LPCWSTR szPath); //    .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 5.3.   .      ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathCreate  PathCreateW
#else
 #define PathCreate  PathCreateA
#endif
//==============================================================================================================================================================================================================================================================
// 6.1.    .   ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathDeleteA(LPCSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.2.    .   ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathDeleteW(LPCWSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 6.3.    .   ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathDelete  PathDeleteW
#else
 #define PathDelete  PathDeleteA
#endif
//==============================================================================================================================================================================================================================================================
// 7.1.    .   ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathDeleteEmptyA(LPCSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.2.    .   ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathDeleteEmptyW(LPCWSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 7.3.    .   ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathDeleteEmpty  PathDeleteEmptyW
#else
 #define PathDeleteEmpty  PathDeleteEmptyA
#endif
//==============================================================================================================================================================================================================================================================
// 8.1.     /      C-      .      / .
//              0.    ANSI-.
EXPFUNC(SIZE_T) PathGetListA(LPCSTR       szPath,   //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                    //   ,         .      ,
                                                    //    ,               .
                             const int    nSearch,  //   : GL_FOLDER -   .
                                                    //                      GL_FILE   -   .
                                                    //                      GL_ALL    -    .
                                   LPSTR  pa2List,  //       C-      .             .
                             const SIZE_T stSize0,  //         .         .
                             const SIZE_T stSize1); //         .           .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.2.     /      C-      .      / .
//              0.    UNICODE-.
EXPFUNC(SIZE_T) PathGetListW(LPCWSTR      szPath,   //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                    //   ,         .      ,
                                                    //    ,               .
                             const int    nSearch,  //   : GL_FOLDER -   .
                                                    //                      GL_FILE   -   .
                                                    //                      GL_ALL    -    .
                                   LPWSTR pa2List,  //       C-      .             .
                             const SIZE_T stSize0,  //         .         .
                             const SIZE_T stSize1); //         .           .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 8.3.     /      C-      .      / .
//              -1.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathGetList  PathGetListW
#else
 #define PathGetList  PathGetListA
#endif
//==============================================================================================================================================================================================================================================================
// 9.1.     /    MQLSTR-      .      / .
//              -1.    ANSI-.
EXPFUNC(SIZE_T) PathGetListMA(LPCSTR             szPath,      //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                              //   ,         .      ,
                                                              //    ,               .
                              const int          nSearch,     //   : GL_FOLDER -   .
                                                              //                      GL_FILE   -   .
                                                              //                      GL_ALL    -    .
                                    MT::PMQLSTRA pamsList,    //     MQLSTR-      .              .
                              const SIZE_T       stSizeList); //       .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 9.2.     /    MQLSTR-      .      / .
//              -1.    UNICODE-.
EXPFUNC(SIZE_T) PathGetListMW(LPCWSTR            szPath,      //   ,      (*  ?).         "c:\filename.txt"     "c:\*.*".
                                                              //   ,         .      ,
                                                              //    ,               .
                              const int          nSearch,     //   : GL_FOLDER -   .
                                                              //                      GL_FILE   -   .
                                                              //                      GL_ALL    -    .
                                    MT::PMQLSTRA pamsList,    //     MQLSTR-      .              .
                              const SIZE_T       stSizeList); //       .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
// 9.3.     /    MQLSTR-      .      / .
//              -1.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathGetMqlStrList  PathGetMqlStrListW
#else
 #define PathGetMqlStrList  PathGetMqlStrListA
#endif
//==============================================================================================================================================================================================================================================================
//10.1.     .   TRUE,      FALSE,         .    ANSI-.
EXPFUNC(BOOL) PathIsEmptyA(LPCSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//10.2.     .   TRUE,      FALSE,         .    UNICODE-.
EXPFUNC(BOOL) PathIsEmptyW(LPCWSTR szPath); //   .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//10.3.     .   TRUE,      FALSE,         .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathIsEmpty  PathIsEmptyW
#else
 #define PathIsEmpty  PathIsEmptyA
#endif
//==============================================================================================================================================================================================================================================================
//11.1.   ()  ,    .    ,   TRUE,  - FALSE.    ANSI-.
EXPFUNC(BOOL) PathMoveA(LPCSTR szExistingPath, //     .
                        LPCSTR szNewPath);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//11.2.   ()  ,    .    ,   TRUE,  - FALSE.    UNICODE-.
EXPFUNC(BOOL) PathMoveW(LPCWSTR szExistingPath, //     .
                        LPCWSTR szNewPath);     //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//11.3.   ()  ,    .    ,   TRUE,  - FALSE.       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathMove  PathMoveW
#else
 #define PathMove  PathMoveA
#endif
//==============================================================================================================================================================================================================================================================
//12.1.       .    ,   TRUE,  - FALSE.      .    ANSI-.
EXPFUNC(BOOL) PathSymbolicLinkA(LPCSTR szExistingDirectory,      //   .
                                LPCSTR szSymbolicLinkDirectory); //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//12.2.       .    ,   TRUE,  - FALSE.      .    UNICODE-.
EXPFUNC(BOOL) PathSymbolicLinkW(LPCWSTR szExistingDirectory,      //   .
                                LPCWSTR szSymbolicLinkDirectory); //     .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//12.3.       .    ,   TRUE,  - FALSE.      .       .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathSymbolicLink  PathSymbolicLinkW
#else
 #define PathSymbolicLink  PathSymbolicLinkA
#endif
//==============================================================================================================================================================================================================================================================
//13.1.                  ,   .       .    ANSI-.
//          ,          .           ,   ,    ,   .
EXPFUNC(LPSTR) PathTrimNameFileA(LPSTR szPathFull); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//13.2.                  ,   .       .    UNICODE-.
//          ,          .           ,   ,    ,   .
EXPFUNC(LPWSTR) PathTrimNameFileW(LPWSTR szPathFull); //  .
//--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//13.3.                  ,   .       .       .
//          ,          .           ,   ,    ,   .
#if defined(UNICODE) || defined(_UNICODE)
 #define PathTrimNameFile  PathTrimNameFileW
#else
 #define PathTrimNameFile  PathTrimNameFileA
#endif
//